<div id="data-spaces">
  <h3 class="mt-0">{{ !isConformanceTest ? "Your Data Spaces" : "" }}</h3>

  <app-search-filters-form
    [isConformanceTest]="isConformanceTest"
    [storedItems]="storedDataSpaces"
    [statuses]="statuses"
    [itemsName]="'Data Spaces'"
    (filterItemsEvent)="onFilterDataSpaces($event)"
  ></app-search-filters-form>

  @if (!isConformanceTest) {
    <p class="dataspaces-number">
      {{
        dataSpaces.length > 0
          ? dataSpaces.length +
            " Data Space" +
            (dataSpaces.length > 1 ? "s" : "") +
            " available"
          : ""
      }}
    </p>
  }

  <mat-grid-list [cols]="cols$ | async" rowHeight="2:1" gutterSize="48px">
    @for (dataSpace of filteredDataSpaces; track dataSpace; let idx = $index) {
      <mat-grid-tile>
        <mat-card
          class="dataspaces-card justify-content-between mat-elevation-z3"
        >
          <mat-card-header>
            <mat-card-title-group class="align-items-center">
              <mat-card-title>{{ dataSpace.name }}</mat-card-title>
              @if (!isConformanceTest) {
                <button
                  class="simplut-menu-btn"
                  color="primary"
                  mat-icon-button
                  [matMenuTriggerFor]="nodeMenu"
                  [disabled]="
                    dataSpace.status !== statuses.RUNNING &&
                    dataSpace.status !== statuses.ERROR
                  "
                  aria-label="Icon button with a horizontal three dot icon"
                >
                  <mat-icon>more_horiz</mat-icon>
                </button>
              }

              <mat-menu class="dataspace-tree-node-menu" #nodeMenu="matMenu">
                <button
                  disableRipple
                  mat-menu-item
                  (click)="deleteDataSpace(dataSpace)"
                >
                  <mat-icon color="warn" class="material-icons-outlined">
                    delete
                  </mat-icon>
                  <span class="text-primary simplut-delete-label"
                    >Delete Data Space</span
                  >
                </button>
              </mat-menu>
            </mat-card-title-group>
          </mat-card-header>

          <div
            class="ec-chips-theme d-flex justify-content-between align-items-center"
          >
            <mat-chip
              highlighted
              class="slabs-chip"
              [color]="status2ChipColor.get(dataSpace.status)"
            >
              {{ dataSpace.status.replaceAll("_", " ") }}
            </mat-chip>
            <span class="dataspaces-date">
              <i>{{ dataSpace.createDate | date: "dd/M/yyyy" }}</i>
            </span>
          </div>

          <mat-card-content>
            <b>{{ dataSpace.nodeList.length }}</b> NODES
            <br />
            <b>{{ nComponents[idx] }}</b> COMPONENTS
          </mat-card-content>

          <mat-card-actions class="justify-content-center align-items-center">
            <button
              mat-stroked-button
              color="primary"
              class="border-primary fs-16 fw-500"
              [disabled]="dataSpace.status !== statuses.RUNNING"
              (click)="viewDataSpace(dataSpace)"
            >
              Interact
            </button>
          </mat-card-actions>
          <mat-card-footer></mat-card-footer>
        </mat-card>
      </mat-grid-tile>
    }

    @if (!isConformanceTest) {
      <mat-grid-tile>
        <mat-card class="dataspaces-card justify-content-between">
          <mat-card-header
            class="d-flex justify-content-center align-items-center"
          >
            <mat-card-title>Create a Data Space</mat-card-title>
          </mat-card-header>

          <div
            mat-card-sm-image
            class="d-flex justify-content-center align-items-center"
          >
            <mat-icon class="add-icon">add</mat-icon>
          </div>

          <mat-card-content
            class="d-flex justify-content-center align-items-center"
          >
            Create a new Data Space starting from a template.
          </mat-card-content>

          <mat-card-actions
            class="d-flex justify-content-center align-items-center"
          >
            <button
              (click)="onCreateDataSpaceClick()"
              mat-flat-button
              color="primary"
            >
              Create Data Space
            </button>
          </mat-card-actions>
          <mat-card-footer></mat-card-footer>
        </mat-card>
      </mat-grid-tile>
    }
  </mat-grid-list>
</div>
